$! Program Name            : UNAME.COM
$!   Original Author       : NUCMGR i.e. JLAURET
$!   Date                  : 13-MAY-1998
$!   Program Description   :  Unix UNAME emulation. Note that the HOSTNAME
$!                         : command depends on this command.
$! Revision History follows
$! ----------------------- : 
$!   Date of Revision      :  6-NOV-1998 
$!   Change Author         : NUCMGR
$!   Purpose of Revision   : Added support for TCPWARE and ARPANET 
$!                         : 
$
$ set symbol/scope=nolocal
$ arg	= f$edit("''p1' ''p2' ''p3' ''p4' ''p5' ''p6' ''p7' ''p8'","COLLAPSE")
$ result= ""
$
$ if arg.eqs."" then arg = "A"
$ version	= f$getsyi("VERSION")
$
$ if f$locate("H",arg).ne.f$length(arg)
$ then
$	write sys$output ""
$	write sys$output "   -m   Print the machine (hardware) type."
$	write sys$output "   -n   Print the machine's network node hostname."
$	write sys$output "   -r   Print the the operating system release"
$	write sys$output "   -s   Print the operating system name."
$	write sys$output "   -v   Print the operating system version."
$	write sys$output "   -a   Print all of the above information."
$	write sys$output "   -c   Print the System PalCode and Console versions."
$	write sys$output "   -p   Print the system processor type."
$	write sys$output "   -x   Print the Windowing System version"
$	write sys$output "   -h   Print a usage message on standard output  and  exit"
$	write sys$output "          "
$	exit
$ endif
$
$ if f$locate("P",arg).ne.f$length(arg)
$ then	if f$getsyi("NODE_HWTYPE").EQS."ALPH"
$	then	result = result+" Alpha"
$	else	result = result+" Vax"
$	endif
$ endif
$
$ if f$locate("S",arg).ne.f$length(arg) .OR. f$locate("A",arg).ne.f$length(arg)
$ then	if version.ges."V6.0"
$	then	result = result + " OpenVMS"
$	else	result = result + " VMS"
$	endif
$ endif
$
$ if f$locate("N",arg).ne.f$length(arg) .OR. f$locate("A",arg).ne.f$length(arg)
$ then	if f$trnlnm("MULTINET_HOST_NAME").nes. ""	! We have multinet
$ 	then cnode = f$trnlnm("MULTINET_HOST_NAME")
$	else ! More general UCX package and UCX emulation
$	     if f$trnlnm("UCX$INET_HOST").nes.""
$	     then cnode = f$trnlnm("UCX$INET_HOST")
$	     else if f$trnlnm("INTERNET_HOST_NAME").nes.""
$		  then	cnode = f$trnlnm("INTERNET_HOST_NAME")
$		  else	if f$trnlnm("TCPWARE_DOMAINNAME").nes.""
$			then	cnode = f$trnlnm("TCPWARE_DOMAINNAME")
$			else	if f$trnlnm("ARPANET_HOST_NAME").nes.""
$				then	cnode = f$trnlnm("ARPANET_HOST_NAME")
$				else	! Otherwise, get nodename only ...
$					cnode = f$getsyi("NODENAME")
$				endif
$			endif
$		  endif
$ 	     endif
$	endif
$	result	= cnode + " " + result
$ endif
$ if f$locate("V",arg).ne.f$length(arg) .OR. f$locate("A",arg).ne.f$length(arg)
$ then	result	= result + " " + f$element(0,"-",version)
$	v_done	= 1
$ else	v_done	= 0
$ endif
$ if f$locate("R",arg).ne.f$length(arg) .OR. f$locate("A",arg).ne.f$length(arg)
$ then	if v_done.eq.1
$	then	result = result + "-" + f$element(1,"-",version)
$	else	result = result + " " + f$element(1,"-",version)
$	endif
$ endif
$
$ if f$locate("M",arg).ne.f$length(arg) .OR. f$locate("A",arg).ne.f$length(arg)
$ then	result = result + " " + f$getsyi("hw_name")
$ endif
$
$ ! *** Compatibility switch for HOSTNAME command. Not a uname command qualifier
$ if f$locate("K",arg).ne.f$length(arg)
$ then	result = result + " " + f$getsyi("nodename")
$ endif
$
$ ! DECW version. Not usually an option for uname ...
$ if f$locate("X",arg).ne.f$length(arg)
$ then	@SYS$UPDATE:DECW$GET_IMAGE_VERSION SYS$SHARE:DECW$XLIBSHR.EXE DECW$VERSION
$	result = result + " " + DECW$VERSION
$ endif
$
$ ! Late addition for fast access to that information
$ if f$locate("C",arg).ne.f$length(arg)
$ then	if f$getsyi("VERSION").ges."V6.2"
$	then	! Those keywords appeared post VMS6.1
$		result = result +- 
			" Console " + f$getsyi("CONSOLE_VERSION") +-
			" PalCode " + f$getsyi("PALCODE_VERSION")
$	else	result = result + " Console (?) PalCode (?)"
$	endif
$ endif
$
$ ! Now print result
$ result	= f$edit(result,"COMPRESS,TRIM")
$ if result.nes.""
$ then	write sys$output result
$ else	write sys$output "uname : Invalid option(s) ''arg'."
$	write sys$output "Try uname -h  for more information."
$ endif
$exit
